<?php
/**
 * A general NodeAptProxy class
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2011 - 2012 Apt-Proxy Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class BaseNodeAptProxy extends BaseHubSystem {
	/**
	 * Whether this apt-proxy is active
	 */
	private $isActive = FALSE;

	/**
	 * Protected constructor
	 *
	 * @param	$className	Name of the class
	 * @return	void
	 */
	protected function __construct ($className) {
		// Call parent constructor
		parent::__construct($className);
	}

	/**
	 * Enables/disables the apt-proxy (just sets a flag)
	 *
	 * @param	$version	Version number of this apt-proxy
	 * @return	void
	 */
	public final function enableIsActive ($isActive = TRUE) {
		$this->isActive = (bool) $isActive;
	}

	/**
	 * Determines whether the apt-proxy is active
	 *
	 * @return	$isActive	Whether the apt-proxy is active
	 */
	public final function isActive () {
		return $this->isActive;
	}
}

// [EOF]
?>
