<?php
/**
 * A MinerTestGenesisBlock producer class
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2011 - 2014 Cruncher Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class MinerTestGenesisBlockProducer extends BaseBlockProducer implements BlockProducer, Registerable {
	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Creates an instance of this class
	 *
	 * @return	$producerInstance	An instance of a Producer class
	 */
	public final static function createMinerTestGenesisBlockProducer () {
		// Get new instance
		$producerInstance = new MinerTestGenesisBlockProducer();

		// Get a (minable) hash block instance
		$minableInstance = ObjectFactory::createObjectByConfiguredName('miner_test_hash_block_class');

		// Set it here
		$producerInstance->setMinableInstance($minableInstance);

		// Return the prepared instance
		return $producerInstance;
	}

	/**
	 * Initializes the producer. This method satisfies the abstract BaseProducer
	 * class.
	 *
	 * @return	void
	 * @todo	~10% done
	 */
	protected function initProducer () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Initializes the executor, whatever it does.
	 *
	 * @return	void
	 * @todo	0% done
	 */
	public function initExecutor (Stateable $stateInstance) {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Prepares the produces of some test units and pushes them onto the queue
	 *
	 * @param	$stateInstance	An instance of a Stateable instance
	 * @return	void
	 * @todo	~5% done
	 */
	public function prepareBlockProduction (Stateable $stateInstance) {
		// The state must be 'booting'
		$stateInstance->validateMinerStateIsBooting();

		/*
		 * Now that the miner is booting a "genesis" block for testing purposes
		 * can be created. The real "genesis" block will be created differently
		 * to this.
		 */
	}
}

// [EOF]
?>
